#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "we.h"
#include "tools.h"
#include "undo.h"
#include "box.h"
#include "allocmem.h"
#include "cursor.h"
#include "mark.h"

#define ON      1
#define OFF     0

extern int                   U_LEN;          //  UnCompress string length
extern int                   C_LEN;          //  Compress   String length
extern char                  U_STR[256];     //  UnCompress String
extern char                  C_STR[256];     //  Compress   String
extern char                  tbl[][3];
extern char                  text[256];
extern char                  old_text[256];
extern char                  FNAME[80];
extern char                  STR[513];
extern char                  BOXSTR[1024];
extern char                  BOXSTR[1024];
extern int                   KEY_STATUS;
extern char                  *DP;

extern struct LINK           *now;
extern struct LINK           *new;
extern struct LINK           *head;
extern struct LINK           *tail;
extern struct LINK           *NEW;
extern struct BACKUP         *ACTIVE;

extern struct CTRL_STRUCT    CTRL;
extern struct POS_STRUCT     POS;
extern struct DISPLAY_STRUCT DISPLAY;
extern struct LAST_STRUCT    LAST;
extern struct LINE_STRUCT    LINE;

int  BOXUP=OFF;
int  BOXDN=OFF;

void BoxMode()
{
   unsigned al,ah;
   int      ch,insert;
   int      BREAK=OFF;
   char     str[90];

   sprintf(str,"[ %c %c %c %c ] ø  [Shift+(DKeyPad)] ʦø  [ESC] ѰA", 0x1b, 0x18, 0x19, 0x1a);
   DisplayMessage(str,ON);

   insert=CTRL.INSERT;
   CTRL.INSERT=OFF;
   while(!BREAK)
   {
      if((ch=GetKey())==-1) continue;
      if(ch==0x1b)          BREAK=ON;   // ESC øؼҦ
      al=((unsigned)ch & 0x00FF);
      ah=((unsigned)ch>>8);
      if(!al)                           // \QUF
      {
         switch(KEY_STATUS)
         {
             case 0x01 :  // Shift +  , ʦø
             case 0x02 :
             case 0x03 :
                  switch(ah)
                  {
                      case 0x47 : // HOME
                           Home();      BREAK=OFF;
                           break;
                      case 0x4f : // END
                           End();       BREAK=OFF;
                           break;
                      case 0x48 : // UP
                           Up();        BREAK=OFF;
                           break;
                      case 0x50 : // DOWN
                           Down();      BREAK=OFF;
                           break;
                      case 0x4b : // LEFT
                           Left();      BREAK=OFF;
                           break;
                      case 0x4d : // RIGHT
                           Right();     BREAK=OFF;
                           break;
                      case 0x49 : // PGUP
                           Pgup();      BREAK=OFF;
                           break;
                      case 0x51 : // PGDN
                           Pgdn();      BREAK=OFF;
                           break;
                  }
                  break;
             case 0x00 :
                  switch(ah)
                  {
                      case 0x4b : // LEFT
                           BoxLeft();   BREAK=OFF;
                           break;
                      case 0x4d : // RIGHT
                           BoxRight();  BREAK=OFF;
                           break;
                      case 0x48 : // UP
                           BoxUp();     BREAK=OFF;
                           break;
                      case 0x50 : // DOWN
                           BoxDown();   BREAK=OFF;
                           break;
                  }
                  break;
         }
      }
      if(!BREAK)
      {
         if(DISPLAY.REDISPLAY)  Redraw(DISPLAY.SCRY,DISPLAY.CNT);
         StatusXY();
         LightLine();
      }
   }
   CTRL.INSERT=insert;
   DisplayMessage(" ",OFF);
   ChangeMessage();
}

void BoxRight()
{
   char str_up[256],str_dn[256],str[256],TBL[40];
   char ch[3];
   int  Lsw=OFF;
   int  Rsw=OFF;
   int  Usw=OFF;
   int  Dsw=OFF;
   int  sw;
   struct LINK *tmp;

   tmp=now->prev;
   if(tmp!=NULL) { PointerData(tmp); sprintf(str_up,"%-255s",U_STR); } else sprintf(str_up,"%-255s"," ");
   tmp=now->next;
   if(tmp!=NULL) { PointerData(tmp); sprintf(str_dn,"%-255s",U_STR); } else sprintf(str_dn,"%-255s"," ");
   if(text[0]!='\0')   sprintf(str   ,"%-255s",text);                  else sprintf(str   ,"%-255s"," ");

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[7],tbl[8],tbl[9],tbl[5],tbl[10],tbl[4],tbl[6]);
   MidStr(ch,str_up,POS.NOWX  ,2);  if(strstr(TBL,ch)!=NULL) Usw=ON;

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[1],tbl[2],tbl[3],tbl[5],tbl[10],tbl[4],tbl[6]);
   MidStr(ch,str_dn,POS.NOWX  ,2);  if(strstr(TBL,ch)!=NULL) Dsw=ON;

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[5],tbl[0],tbl[6],tbl[9],tbl[2],tbl[8],tbl[3]);
   MidStr(ch,str   ,POS.NOWX+2,2);  if(strstr(TBL,ch)!=NULL) Rsw=ON;

   if(POS.NOWX>2)
   {
      sprintf(TBL,"%s%s%s%s%s%s%s",tbl[5],tbl[0],tbl[4],tbl[7],tbl[2],tbl[8],tbl[1]);
      MidStr(ch,str   ,POS.NOWX-2,2);  if(strstr(TBL,ch)!=NULL)  Lsw=ON;
   }

   sw=0;
   if(Usw) sw |= 0x01;
   if(Dsw) sw |= 0x02;
   if(Rsw) sw |= 0x04;
   if(Lsw) sw |= 0x08;

   switch(sw)
   {
      case  0 : KeyNormal((int)(tbl[0][0])); KeyNormal((int)(tbl[0][1])); break;   // w  0
      case  1 : KeyNormal((int)(tbl[1][0])); KeyNormal((int)(tbl[1][1])); break;   // |  1
      case  2 : KeyNormal((int)(tbl[7][0])); KeyNormal((int)(tbl[7][1])); break;   // z  7
      case  3 : KeyNormal((int)(tbl[4][0])); KeyNormal((int)(tbl[4][1])); break;   // u  4
      case  4 : KeyNormal((int)(tbl[0][0])); KeyNormal((int)(tbl[0][1])); break;   // w  0
      case  5 : KeyNormal((int)(tbl[1][0])); KeyNormal((int)(tbl[1][1])); break;   // |  1
      case  6 : KeyNormal((int)(tbl[7][0])); KeyNormal((int)(tbl[7][1])); break;   // z  7
      case  7 : KeyNormal((int)(tbl[4][0])); KeyNormal((int)(tbl[4][1])); break;   // u  4
      case  8 : KeyNormal((int)(tbl[0][0])); KeyNormal((int)(tbl[0][1])); break;   // w  0
      case  9 : KeyNormal((int)(tbl[2][0])); KeyNormal((int)(tbl[2][1])); break;   // r  2
      case 10 : KeyNormal((int)(tbl[8][0])); KeyNormal((int)(tbl[8][1])); break;   // s  8
      case 11 : KeyNormal((int)(tbl[5][0])); KeyNormal((int)(tbl[5][1])); break;   // q  5
      case 12 : KeyNormal((int)(tbl[0][0])); KeyNormal((int)(tbl[0][1])); break;   // w  0
      case 13 : KeyNormal((int)(tbl[2][0])); KeyNormal((int)(tbl[2][1])); break;   // r  2
      case 14 : KeyNormal((int)(tbl[8][0])); KeyNormal((int)(tbl[8][1])); break;   // s  8
      case 15 : KeyNormal((int)(tbl[5][0])); KeyNormal((int)(tbl[5][1])); break;   // q  5
   }
   BoxModify(0,0);
}

void BoxLeft()
{
   char str_up[256],str_dn[256],str[256],TBL[40];
   char ch[3];
   int  Lsw=OFF;
   int  Rsw=OFF;
   int  Usw=OFF;
   int  Dsw=OFF;
   int  sw;
   struct LINK *tmp;

   if(POS.NOWX<3) return;
   tmp=now->prev;
   if(tmp!=NULL) { PointerData(tmp); sprintf(str_up,"%-255s",U_STR); } else sprintf(str_up,"%-255s"," ");
   tmp=now->next;
   if(tmp!=NULL) { PointerData(tmp); sprintf(str_dn,"%-255s",U_STR); } else sprintf(str_dn,"%-255s"," ");
   if(text[0]!='\0')   sprintf(str   ,"%-255s",text);              else sprintf(str   ,"%-255s"," ");

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[5],tbl[0],tbl[6],tbl[9],tbl[2],tbl[8],tbl[3]);
   MidStr(ch,str   ,POS.NOWX  ,2);     if(strstr(TBL,ch)!=NULL) Rsw=ON;
   if(POS.NOWX>2)
   {
      sprintf(TBL,"%s%s%s%s%s%s%s",tbl[7],tbl[8],tbl[9],tbl[5],tbl[10],tbl[4],tbl[6]);
      MidStr(ch,str_up,POS.NOWX-2,2);  if(strstr(TBL,ch)!=NULL) Usw=ON;

      sprintf(TBL,"%s%s%s%s%s%s%s",tbl[1],tbl[2],tbl[3],tbl[5],tbl[10],tbl[4],tbl[6]);
      MidStr(ch,str_dn,POS.NOWX-2,2);  if(strstr(TBL,ch)!=NULL) Dsw=ON;
   }
   if(POS.NOWX>4)
   {
      sprintf(TBL,"%s%s%s%s%s%s%s",tbl[5],tbl[0],tbl[4],tbl[7],tbl[2],tbl[8],tbl[1]);
      MidStr(ch,str   ,POS.NOWX-4,2);  if(strstr(TBL,ch)!=NULL) Lsw=ON;
   }

   sw=0;
   if(Usw) sw |= 0x01;
   if(Dsw) sw |= 0x02;
   if(Rsw) sw |= 0x04;
   if(Lsw) sw |= 0x08;

   Left();
   Left();
   switch(sw)
   {
      case  0 : KeyNormal((int)(tbl[0][0])); KeyNormal((int)(tbl[0][1])); break;   // w 0
      case  1 : KeyNormal((int)(tbl[3][0])); KeyNormal((int)(tbl[3][1])); break;   // } 3
      case  2 : KeyNormal((int)(tbl[9][0])); KeyNormal((int)(tbl[9][1])); break;   // { 9
      case  3 : KeyNormal((int)(tbl[6][0])); KeyNormal((int)(tbl[6][1])); break;   // t 6
      case  4 : KeyNormal((int)(tbl[0][0])); KeyNormal((int)(tbl[0][1])); break;   // w 0
      case  5 : KeyNormal((int)(tbl[2][0])); KeyNormal((int)(tbl[2][1])); break;   // r 2
      case  6 : KeyNormal((int)(tbl[8][0])); KeyNormal((int)(tbl[8][1])); break;   // s 8
      case  7 : KeyNormal((int)(tbl[5][0])); KeyNormal((int)(tbl[5][1])); break;   // q 5
      case  8 : KeyNormal((int)(tbl[0][0])); KeyNormal((int)(tbl[0][1])); break;   // w 0
      case  9 : KeyNormal((int)(tbl[3][0])); KeyNormal((int)(tbl[3][1])); break;   // } 3
      case 10 : KeyNormal((int)(tbl[9][0])); KeyNormal((int)(tbl[9][1])); break;   // { 9
      case 11 : KeyNormal((int)(tbl[6][0])); KeyNormal((int)(tbl[6][1])); break;   // t 6
      case 12 : KeyNormal((int)(tbl[0][0])); KeyNormal((int)(tbl[0][1])); break;   // w 0
      case 13 : KeyNormal((int)(tbl[2][0])); KeyNormal((int)(tbl[2][1])); break;   // r 2
      case 14 : KeyNormal((int)(tbl[8][0])); KeyNormal((int)(tbl[8][1])); break;   // s 8
      case 15 : KeyNormal((int)(tbl[5][0])); KeyNormal((int)(tbl[5][1])); break;   // q 5
   }
   Left();
   Left();
   if(POS.NOWX>2)     BoxModify(0,-2);
   if(BOXUP || BOXDN) { BoxModify(0, 2); BOXUP=OFF; BOXDN=OFF; }
}


void BoxUp()
{
   char str_up[256],str_dn[256],str[256],TBL[40];
   char ch[3];
   int  Lsw=OFF;
   int  Rsw=OFF;
   int  Usw=OFF;
   int  Dsw=OFF;
   int  sw;
   struct LINK *tmp;

   if(POS.NOWY==1) return;
   tmp=now->prev;
   if(tmp!=NULL) { PointerData(tmp); sprintf(str_up,"%-255s",U_STR); } else sprintf(str_up,"%-255s"," ");
   tmp=now->next;
   if(tmp!=NULL) { PointerData(tmp); sprintf(str_dn,"%-255s",U_STR); } else sprintf(str_dn,"%-255s"," ");
   if(text[0]!='\0')   sprintf(str   ,"%-255s",text);              else sprintf(str   ,"%-255s"," ");

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[7],tbl[8],tbl[9],tbl[5],tbl[10],tbl[4],tbl[6]);
   MidStr(ch,str_up,POS.NOWX  ,2);  if(strstr(TBL,ch)!=NULL) Usw=ON;

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[1],tbl[2],tbl[3],tbl[5],tbl[10],tbl[4],tbl[6]);
   MidStr(ch,str_dn,POS.NOWX  ,2);  if(strstr(TBL,ch)!=NULL) Dsw=ON;

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[5],tbl[0],tbl[6],tbl[9],tbl[2],tbl[8],tbl[3]);
   MidStr(ch,str   ,POS.NOWX+2,2);  if(strstr(TBL,ch)!=NULL) Rsw=ON;
   if(POS.NOWX>2)
   {
      sprintf(TBL,"%s%s%s%s%s%s%s",tbl[5],tbl[0],tbl[4],tbl[7],tbl[2],tbl[8],tbl[1]);
      MidStr(ch,str,POS.NOWX-2,2);  if(strstr(TBL,ch)!=NULL)  Lsw=ON;
   }

   BOXUP=ON;
   sw=0;
   if(Usw) sw |= 0x01;
   if(Dsw) sw |= 0x02;
   if(Rsw) sw |= 0x04;
   if(Lsw) sw |= 0x08;

   switch(sw)
   {
      case  0 : KeyNormal((int)(tbl[10][0])); KeyNormal((int)(tbl[10][1])); break;   // x 10
      case  1 : KeyNormal((int)(tbl[10][0])); KeyNormal((int)(tbl[10][1])); break;   // x 10
      case  2 : KeyNormal((int)(tbl[10][0])); KeyNormal((int)(tbl[10][1])); break;   // x 10
      case  3 : KeyNormal((int)(tbl[10][0])); KeyNormal((int)(tbl[10][1])); break;   // x 10
      case  4 : KeyNormal((int)(tbl[1][0] )); KeyNormal((int)(tbl[1][1] )); break;   // | 1
      case  5 : KeyNormal((int)(tbl[1][0] )); KeyNormal((int)(tbl[1][1] )); break;   // | 1
      case  6 : KeyNormal((int)(tbl[4][0] )); KeyNormal((int)(tbl[4][1] )); break;   // u 4
      case  7 : KeyNormal((int)(tbl[4][0] )); KeyNormal((int)(tbl[4][1] )); break;   // u 4
      case  8 : KeyNormal((int)(tbl[3][0] )); KeyNormal((int)(tbl[3][1] )); break;   // } 3
      case  9 : KeyNormal((int)(tbl[3][0] )); KeyNormal((int)(tbl[3][1] )); break;   // } 3
      case 10 : KeyNormal((int)(tbl[6][0] )); KeyNormal((int)(tbl[6][1] )); break;   // t 6
      case 11 : KeyNormal((int)(tbl[6][0] )); KeyNormal((int)(tbl[6][1] )); break;   // t 6
      case 12 : KeyNormal((int)(tbl[2][0] )); KeyNormal((int)(tbl[2][1] )); break;   // r 2
      case 13 : KeyNormal((int)(tbl[2][0] )); KeyNormal((int)(tbl[2][1] )); break;   // r 2
      case 14 : KeyNormal((int)(tbl[5][0] )); KeyNormal((int)(tbl[5][1] )); break;   // q 5
      case 15 : KeyNormal((int)(tbl[5][0] )); KeyNormal((int)(tbl[5][1] )); break;   // q 5
   }
   Left();
   Left();
   Up();
   BoxModify(0,0);
}

void BoxDown()
{
   char str_up[256],str_dn[256],str[256],TBL[40];
   char ch[3];
   int  Lsw=OFF;
   int  Rsw=OFF;
   int  Usw=OFF;
   int  Dsw=OFF;
   int  sw;
   struct LINK *tmp;

   if(POS.NOWY==POS.MAXY)                       // wb̫, ۰ʦVUsW@
   {
      if((new=AllocMemString(""))==NULL) return;
      PointerData(new);
      strcpy(DP,"\0");
      new->next=NULL;
      tail     =new;
      new->prev=now;
      now->next=new;
      POS.MAXY++;
      if(POS.SCRY!=LINE.SCRY1)                     // ù̩, ХHUU
      {
         RollDown(1,1,POS.SCRY+1,80,LINE.SCRY1,0x07);
      }
   }
   tmp=now->prev;
   if(tmp!=NULL) { PointerData(tmp); sprintf(str_up,"%-255s",U_STR); } else sprintf(str_up,"%-255s"," ");
   tmp=now->next;
   if(tmp!=NULL) { PointerData(tmp); sprintf(str_dn,"%-255s",U_STR); } else sprintf(str_dn,"%-255s"," ");
   if(text[0]!='\0')   sprintf(str   ,"%-255s",text);                  else sprintf(str   ,"%-255s"," ");

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[7],tbl[8],tbl[9],tbl[5],tbl[10],tbl[4],tbl[6]);
   MidStr(ch,str_up,POS.NOWX  ,2);  if(strstr(TBL,ch)!=NULL) Usw=ON;

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[1],tbl[2],tbl[3],tbl[5],tbl[10],tbl[4],tbl[6]);
   MidStr(ch,str_dn,POS.NOWX  ,2);  if(strstr(TBL,ch)!=NULL) Dsw=ON;

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[5],tbl[0],tbl[6],tbl[9],tbl[2],tbl[8],tbl[3]);
   MidStr(ch,str   ,POS.NOWX+2,2);  if(strstr(TBL,ch)!=NULL) Rsw=ON;
   if(POS.NOWX>2)
   {
      sprintf(TBL,"%s%s%s%s%s%s%s",tbl[5],tbl[0],tbl[4],tbl[7],tbl[2],tbl[8],tbl[1]);
      MidStr(ch,str,POS.NOWX-2,2);  if(strstr(TBL,ch)!=NULL) Lsw=ON;
   }

   BOXDN=ON;
   sw=0;
   if(Usw) sw |= 0x01;
   if(Dsw) sw |= 0x02;
   if(Rsw) sw |= 0x04;
   if(Lsw) sw |= 0x08;

   switch(sw)
   {
      case  0 : KeyNormal((int)(tbl[10][0])); KeyNormal((int)(tbl[10][1])); break;   // x 10
      case  1 : KeyNormal((int)(tbl[10][0])); KeyNormal((int)(tbl[10][1])); break;   // x 10
      case  2 : KeyNormal((int)(tbl[10][0])); KeyNormal((int)(tbl[10][1])); break;   // x 10
      case  3 : KeyNormal((int)(tbl[10][0])); KeyNormal((int)(tbl[10][1])); break;   // x 10
      case  4 : KeyNormal((int)(tbl[7][0]) ); KeyNormal((int)(tbl[7][1]) ); break;   // z 7
      case  5 : KeyNormal((int)(tbl[4][0]) ); KeyNormal((int)(tbl[4][1]) ); break;   // u 4
      case  6 : KeyNormal((int)(tbl[7][0]) ); KeyNormal((int)(tbl[7][1]) ); break;   // z 7
      case  7 : KeyNormal((int)(tbl[4][0]) ); KeyNormal((int)(tbl[4][1]) ); break;   // u 4
      case  8 : KeyNormal((int)(tbl[9][0]) ); KeyNormal((int)(tbl[9][1]) ); break;   // { 9
      case  9 : KeyNormal((int)(tbl[6][0]) ); KeyNormal((int)(tbl[6][1]) ); break;   // t 6
      case 10 : KeyNormal((int)(tbl[9][0]) ); KeyNormal((int)(tbl[9][1]) ); break;   // { 9
      case 11 : KeyNormal((int)(tbl[6][0]) ); KeyNormal((int)(tbl[6][1]) ); break;   // t 6
      case 12 : KeyNormal((int)(tbl[8][0]) ); KeyNormal((int)(tbl[8][1]) ); break;   // s 8
      case 13 : KeyNormal((int)(tbl[5][0]) ); KeyNormal((int)(tbl[5][1]) ); break;   // q 5
      case 14 : KeyNormal((int)(tbl[8][0]) ); KeyNormal((int)(tbl[8][1]) ); break;   // s 8
      case 15 : KeyNormal((int)(tbl[5][0]) ); KeyNormal((int)(tbl[5][1]) ); break;   // q 5
   }
   Left();
   Left();
   Down();
   BoxModify(0,0);
}


void BoxModify(int offy,int offx)
{
   char str_up[256],str_dn[256],str[256],TBL[40];
   char ch[3];
   int  Lsw=OFF;
   int  Rsw=OFF;
   int  Usw=OFF;
   int  Dsw=OFF;
   int  sw,i;
   struct LINK *tmp;

   if(offy>0) { for(i=0;i<offy;i++) Down();  } else { for(i=0;i>offy;i--) Up();   }
   if(offx>0) { for(i=0;i<offx;i++) Right(); } else { for(i=0;i>offx;i--) Left(); }

   tmp=now->prev;
   if(tmp!=NULL) { PointerData(tmp); sprintf(str_up,"%-255s",U_STR); } else sprintf(str_up,"%-255s"," ");
   tmp=now->next;
   if(tmp!=NULL) { PointerData(tmp); sprintf(str_dn,"%-255s",U_STR); } else sprintf(str_dn,"%-255s"," ");
   if(text[0]  !='\0') sprintf(str   ,"%-255s", text            ); else sprintf(str   ,"%-255s"," ");

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[7],tbl[8],tbl[9],tbl[5],tbl[10],tbl[4],tbl[6]);
   MidStr(ch,str_up,POS.NOWX  ,2);  if(strstr(TBL,ch)!=NULL) Usw=ON;

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[1],tbl[2],tbl[3],tbl[5],tbl[10],tbl[4],tbl[6]);
   MidStr(ch,str_dn,POS.NOWX  ,2);  if(strstr(TBL,ch)!=NULL) Dsw=ON;

   sprintf(TBL,"%s%s%s%s%s%s%s",tbl[5],tbl[0],tbl[6],tbl[9],tbl[2],tbl[8],tbl[3]);
   MidStr(ch,str   ,POS.NOWX+2,2);  if(strstr(TBL,ch)!=NULL) Rsw=ON;
   if(POS.NOWX>2)
   {
      sprintf(TBL,"%s%s%s%s%s%s%s",tbl[5],tbl[0],tbl[4],tbl[7],tbl[2],tbl[8],tbl[1]);
      MidStr(ch,str,POS.NOWX-2,2);  if(strstr(TBL,ch)!=NULL) Lsw=ON;
   }

   sw=0;
   if(Usw) sw |= 0x01;
   if(Dsw) sw |= 0x02;
   if(Rsw) sw |= 0x04;
   if(Lsw) sw |= 0x08;

   switch(sw)
   {
      case  0: break;
      case  1: break;
      case  2: break;
      case  3: KeyNormal((int)(tbl[10][0])); KeyNormal((int)(tbl[10][1])); offx +=2; break; // x 10
      case  4: break;
      case  5: KeyNormal((int)(tbl[1][0] )); KeyNormal((int)(tbl[1][1] )); offx +=2; break; // | 1
      case  6: KeyNormal((int)(tbl[7][0] )); KeyNormal((int)(tbl[7][1] )); offx +=2; break; // z 7
      case  7: KeyNormal((int)(tbl[4][0] )); KeyNormal((int)(tbl[4][1] )); offx +=2; break; // u 4
      case  8: break;
      case  9: KeyNormal((int)(tbl[3][0] )); KeyNormal((int)(tbl[3][1] )); offx +=2; break; // } 3
      case 10: KeyNormal((int)(tbl[9][0] )); KeyNormal((int)(tbl[9][1] )); offx +=2; break; // { 9
      case 11: KeyNormal((int)(tbl[6][0] )); KeyNormal((int)(tbl[6][1] )); offx +=2; break; // t 6
      case 12: KeyNormal((int)(tbl[0][0] )); KeyNormal((int)(tbl[0][1] )); offx +=2; break; // w 0
      case 13: KeyNormal((int)(tbl[2][0] )); KeyNormal((int)(tbl[2][1] )); offx +=2; break; // r 2
      case 14: KeyNormal((int)(tbl[8][0] )); KeyNormal((int)(tbl[8][1] )); offx +=2; break; // s 8
      case 15: KeyNormal((int)(tbl[5][0] )); KeyNormal((int)(tbl[5][1] )); offx +=2; break; // q 5
   }
   if(offy>0) { for(i=0;i<offy;i++) Up();   } else { for(i=0;i>offy;i--) Down();  }
   if(offx>0) { for(i=0;i<offx;i++) Left(); } else { for(i=0;i>offx;i--) Right(); }
}


void BoxAuto()
{
   static int    undo;
   struct BACKUP *BAKtmp=NULL;
   struct LINK   *tmp;
   char          RT[3],RB[3],LT[3],LB[3];
   int           i,j,len,cnt,sw;
   char          str[256],str1[256];
   char          *ts,*ts1;
   int           markx, markx1;

   if(!CTRL.MARK)
   {
      DisplayMessage("T : ХаOت϶",ON);
      return;
   }

   if(!(LAST.keystatus==0x04 && LAST.code==0x02)) undo=OFF;

   markx =POS.MARKX ;
   markx1=POS.MARKX1;
   if(POS.MARKX==0)  { POS.MARKX=1; POS.MARKX1=255; }

   if(POS.MARKX==POS.MARKX1) return;
   if((POS.MARKX1-POS.MARKX)>=3)
   {
      if(POS.MARKY!=POS.MARKY1)
      {
         strcpy(LT,tbl[7]);  strcpy(RT,tbl[9]);                 // z {
         strcpy(LB,tbl[1]);  strcpy(RB,tbl[3]);                 // | }
      }
      else
      {
         strcpy(LT,tbl[0]);  strcpy(RT,tbl[0]);                 // w w
         strcpy(LB,tbl[0]);  strcpy(RB,tbl[0]);                 // w w
      }
   }
   else
   {
      strcpy(LT,tbl[10]);  strcpy(RT,tbl[10]);                  // x x
      strcpy(LB,tbl[10]);  strcpy(RB,tbl[10]);                  // x x
   }

   if(CTRL.MARKFILE!=ACTIVE)
   {
      BAKtmp=ACTIVE;
      ChangeEditStatus(CTRL.MARKFILE);
   }

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;
   tmp=head;
   for(i=1;i<POS.MARKY;i++) tmp=tmp->next;      // V POS.MARKY 檺

   for(i=POS.MARKY, cnt=0;i<=POS.MARKY1;i++)
   {
      PointerData(tmp);
      strcpy(str,U_STR);
      len=U_LEN;
      if(POS.MARKX1>len)                        //  MARK ϸɪť
      {
         for(j=len;j<POS.MARKX1;j++) str[j]=' ';
         str[POS.MARKX1] ='\0';
      }

      if(i==POS.MARKY)
      {
         strcpy(str1,LT);
         for(j=(POS.MARKX+2); j<(POS.MARKX1-2); j+=2) strcat(str1,tbl[0]);
         if((POS.MARKX1-POS.MARKX)>=3) strcat(str1,RT);
      }
      else
      {
         if(i==POS.MARKY1)
         {
            strcpy(str1,LB);
            for(j=(POS.MARKX+2); j<(POS.MARKX1-2); j+=2) strcat(str1,tbl[0]);
            if((POS.MARKX1-POS.MARKX)>=3) strcat(str1,RB);
         }
         else
         {
            strcpy(str1,tbl[10]);
            for(j=(POS.MARKX+2); j<(POS.MARKX1-2); j+=2) strcat(str1,"  ");
            if((POS.MARKX1-POS.MARKX)>=3) strcat(str1,tbl[10]);
         }
      }
      ts =str+POS.MARKX-1;
      ts1=str1;

      while(*ts1!='\0')
      {
         if(*ts1!=' ')
         {
            if(!undo)
            {
               if(cnt<1024) BOXSTR[cnt++]=*ts;
               *ts=*ts1;
            }
            else
            {
               *ts=BOXSTR[cnt++];
            }
         }
         ts++;
         ts1++;
      }

      //--------------  POS.MAXY, H@ UndoAppend() ------------
      NowdataToText(tmp);
      if(strcmp(old_text,str)!=0) UndoAppend(old_text,1);

      for(j=(strlen(str)-1);j>=0;j--) { if(str[j]==' ') str[j]=0; else break; }
      //-------------  now=tmp , now ]QV NEW ------------
      if(tmp==now) { sw=MallocData(tmp,str); now=NEW; } else sw=MallocData(tmp,str);
      if(!sw) break;
      tmp=NEW;
      tmp=tmp->next;
   }
   NowdataToText(now);

   if(!undo && cnt<1024)
   {
      DisplayMessageNoBeep(" Ctrl-B i^_ø");  undo=ON;
   }
   else
   {
      DisplayMessage(" ",OFF);                           undo=OFF;
   }

   if(BAKtmp!=NULL)                     // MARK ɤu@ , ݭs
   {
      ChangeEditStatus(BAKtmp);
      DISPLAY.REDISPLAY=OFF;
      DISPLAY.SCRY     =1;
      DISPLAY.CNT      =0;
   }
   else
   {
      // ------------ P_ɮ׬O_Qק -------------
      if(CTRL.MODIFY==OFF)
      {
         CTRL.MODIFY=ON;
         DisplayFname(FNAME);
      }

      // ---- P_ MARK ϰO_bثeܪϰ ---
      CompareRedrawArea(POS.MARKY, POS.MARKY1, &i, &j);
      CompareRedraw(i,j);
   }

   POS.MARKX =markx;
   POS.MARKX1=markx1;
}

int BoxGrid(char *xstr, char *ystr, char *lstr, char *wstr)
{
   struct LINK   *pnow;
   struct LINK   *new;
   struct LINK   *buf;
   int           i,j,k;
   int           EXIT=OFF;
   char          str[513];
   char          head1[513], head2[256], head3[256], head4[256];
   int           xcnt,ycnt,lcnt,wcnt;

   xcnt=atoi(xstr); if(xcnt<=0)  xcnt=1;
   ycnt=atoi(ystr); if(ycnt<=0)  ycnt=1;
   wcnt=atoi(wstr); if(wcnt<=0)  wcnt=1;
   lcnt=atoi(lstr); if(lcnt<=0)  lcnt=1;

   MallocData(now,text);        // ǤJM᪺ now V@, H NEW @ǻ
   now=NEW;

   for(i=0,str[0]='\0';i<wcnt && strlen(str)<256;i++) strcat(str,tbl[0]);
   if((strlen(str)+POS.NOWX)>256 && !CTRL.MACRO)
   {
       DisplayMessage("T : Grid ׶WL 256 Эsw",ON);  return(0);
   }

   // ------- ͳ̤W䪺ؽu zwwwswwwwswww{ ---------
   strcpy(head1,tbl[7]);
   strcat(head1,str);
   for(i=0;i<(xcnt-1) && strlen(head1)<256;i++) { strcat(head1,tbl[8]); strcat(head1,str); }
   strcat(head1,tbl[9]);
   if((strlen(head1)+POS.NOWX)>256 && !CTRL.MACRO)
   {
       DisplayMessage("T : Grid ׶WL 256 Эsw",ON);  return(0);
   }

   // ------- ͳ̤ؽu uwwwqwwwwqwwwt ---------
   strcpy(head2,tbl[4]);
   strcat(head2,str);
   for(i=0;i<(xcnt-1);i++) { strcat(head2,tbl[5]); strcat(head2,str); }
   strcat(head2,tbl[6]);

   // ------- ͳ̤U䪺ؽu |wwwrwwwwrwww} ---------
   strcpy(head3,tbl[1]);
   strcat(head3,str);
   for(i=0;i<(xcnt-1);i++) { strcat(head3,tbl[2]); strcat(head3,str); }
   strcat(head3,tbl[3]);

   // ------- ͳ̤ؽu x      x        x      x ---------
   for(i=0,str[0]='\0';i<wcnt;i++) strcat(str,"  ");
   strcpy(head4,tbl[10]);
   strcat(head4,str);
   for(i=0;i<(xcnt-1);i++) { strcat(head4,tbl[10]); strcat(head4,str); }
   strcat(head4,tbl[10]);

   pnow=now;
   for(i=0;i<ycnt && !EXIT;i++)
   {
      for(j=0;j<=lcnt;j++)
      {
         // ----------------- HЩҦb X y }lø ---------------
         for(k=0;k<(POS.NOWX-1);k++) str[k]=' ';
         str[k]='\0';

         if(j==0) { if(i==0) strcat(str,head1); else strcat(str,head2); } else { strcat(str,head4); }

         CompressSpace(STR,str);
         if((new=AllocMemString(STR))==NULL) { EXIT=ON; break; }
         PointerData(new);
         strcpy(DP,STR);
         if(pnow->next!=NULL)
         {
            buf=pnow->next;                            // relink pointer
            buf->prev=new;
            new->next=pnow->next;
         }
         else
         {
            new->next=NULL;
            tail     =new;
         }
         new->prev =pnow;
         pnow->next=new;
         pnow      =new;
         POS.MAXY++;
      }
   }

   // ------- øX̤U䪺ؽu |wwwrwwwwrwww} ---------
   if(!EXIT)
   {
      for(k=0;k<(POS.NOWX-1);k++) str[k]=' ';
      str[k]='\0';
      strcat(str,head3);
      CompressSpace(STR,str);
      if((new=AllocMemString(STR))!=NULL)
      {
         PointerData(new);
         strcpy(DP,STR);
         if(pnow->next!=NULL)
         {
            buf      =pnow->next;                          // relink pointer
            buf->prev=new;
            new->next=pnow->next;
         }
         else
         {
            new->next=NULL;
            tail     =new;
         }
         new->prev =pnow;
         pnow->next=new;
         pnow      =new;
         POS.MAXY++;
      }
   }

   // ------------ P_ɮ׬O_Qק -------------
   if(CTRL.MODIFY==OFF)
   {
      CTRL.MODIFY=ON;
      DisplayFname(FNAME);
   }

   // ---- P_ MARK ϰO_bثeܪϰ ---
   CompareRedraw(POS.SCRY,(LINE.SCRY1-LINE.SCRY+1));
   return(1);
}


//------------------------------------------------------------
//   1234567890123456
// 1 - +           + ---> pos[0]
// 2                       - ---> pos[1]
// 3                       * ---> pos[2]
// 4                       / ---> pos[3]
// 5 * /
//------------------------------------------------------------
void BoxInput()
{
   int sw,EXIT=OFF;
   int marky,marky1;
   int markx,markx1;
   int my,my1;
   int mx,mx1;

   if(BoxInput1(&marky, &marky1, &markx, &markx1)==0) { DisplayMessage("Фbʳؤ",ON); return; }

   MarkPush();
   CTRL.MARK=ON;
   CTRL.MARKFILE=ACTIVE;

   while(!EXIT)
   {
      POS.MARKY =marky ;
      POS.MARKY1=marky1;
      POS.MARKX =markx ;
      POS.MARKX1=markx1;

      CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
      Redraw(DISPLAY.SCRY,DISPLAY.CNT);
      LightLine();
      StatusXY();

      if((sw=MarkInput(1))==0) EXIT=ON;
      switch(sw)
      {
         case 1 : // UP
              if(POS.NOWY<=2) break;
              Up(); Up();
              if(BoxInput1(&my,&my1,&mx,&mx1)!=0) { marky=my; marky1=my1; markx=mx; markx1=mx1; } else { Down(); Down(); }
              break;
         case 2 : // Down
              if((POS.MAXY-POS.NOWY)<=2) break;
              Down(); Down();
              if(BoxInput1(&my,&my1,&mx,&mx1)!=0) { marky=my; marky1=my1; markx=mx; markx1=mx1; } else { Up(); Up(); }
              break;
         case 3 : // Left
              if(POS.NOWX<=3) break;
              Left();
              Left();
              Left();
              if(BoxInput1(&my,&my1,&mx,&mx1)!=0) { marky=my; marky1=my1; markx=mx; markx1=mx1; } else { Right(); Right(); Right(); }
              break;
         case 4 : // Right
              if(POS.NOWX>=254) break;
              Right();
              Right();
              if(BoxInput1(&my,&my1,&mx,&mx1)!=0) { marky=my; marky1=my1; markx=mx; markx1=mx1; } else { Left(); Left(); }
              break;
      }

   }
   UnMark();
   MarkPop();
}


int BoxInput1(int *marky, int *marky1, int *markx, int *markx1)
{
   int         i,rightx;
   int         FIND=OFF;
   char        str[256];
   char        ch[3];
   char        *ts,*ss;
   struct LINK *tmp;
   struct XY { int x,y; } pos[4];

   if(CTRL.COMMAND) CommandToggle();

   if(strlen(text)<=POS.NOWX) { return(0); }
   ts=text+POS.NOWX;
   while(1)
   {
      ss=ts;
      while(*ss!='\0')
      {
         ch[0]=*ss;
         if(*(ss+1)!='\0') ch[1]=*(ss+1); else ch[1]=' ';
         ch[2]='\0';
         if(strstr("xu",ch)!=NULL) break; else ss++;
      }
      if(*ss=='\0') { return(0); } else ts=ss;

      rightx=ts-text+1;
      ts+=2;

      //--------------------- O_Oӫʳ ------------------------
      // VWP_ (kW pos[0].x,pos[0].y)
      tmp     =now;
      FIND    =OFF;
      pos[0].y=POS.NOWY;
      while(1)
      {
         if((tmp=tmp->prev)==NULL) { FIND=OFF; break; }
         PointerData(tmp);
         if(U_LEN<=rightx)         { FIND=OFF; break; }

         str[0]=U_STR[rightx-1];
         str[1]=U_STR[rightx];
         str[2]='\0';
         pos[0].y--;
         if(strstr("{stq",str)!=NULL)
         {
            pos[0].x=rightx;
            FIND=ON;
            break;
         }
         if(strstr("xu",str)==NULL) { FIND=OFF; break; }
      }
      if(FIND==OFF) continue;

      // VP_ (W pos[1].x, pos[1].y)
      FIND=OFF;
      for(i=(pos[0].x-2); i>0; i-=2)
      {
         str[0]=U_STR[i-1];
         str[1]=U_STR[i];
         str[2]='\0';
         if(strstr("zsuq~",str)!=NULL)
         {
            pos[1].x=i;
            pos[1].y=pos[0].y;
            FIND=ON;
            break;
         }
         if(strstr("wr",str)==NULL) { FIND=OFF; break; }
      }
      if(FIND==OFF) continue;

      // VUP_ (U pos[2].x,pos[2].y)
      FIND    =OFF;
      pos[2].y=pos[1].y;
      while(1)
      {
         if((tmp=tmp->next)==NULL) { FIND=OFF; break; }
         PointerData(tmp);
         if(U_LEN<=pos[1].x)       { FIND=OFF; break; }

         str[0]=U_STR[pos[1].x-1];
         str[1]=U_STR[pos[1].x];
         str[2]='\0';
         pos[2].y++;
         if(strstr("|ruq",str)!=NULL)
         {
            pos[2].x=pos[1].x;
            FIND=ON;
            break;
         }
         if(strstr("xt",str)==NULL) { FIND=OFF; break; }
      }
      if(FIND==OFF) continue;

      // VkP_ (kU pos[3].x, pos[3].y)
      FIND=OFF;
      for(i=pos[2].x+2; i<U_LEN; i+=2)
      {
         str[0]=U_STR[i-1];
         str[1]=U_STR[i];
         str[2]='\0';
         if(strstr("}rtq",str)!=NULL)
         {
            pos[3].x=i;
            pos[3].y=pos[2].y;
            FIND=ON;
            break;
         }
         if(strstr("ws",str)==NULL) { FIND=OFF; break; }
      }
      //if(FIND==OFF) { DisplayMessage("Фbʳؤ",ON); return(0); }
      if(FIND==OFF) { return(0); }

      // --------------------- O_@ʳ ---------------------
      if((pos[3].y-pos[0].y)< 2) continue;              // LZ
      if((pos[0].x-pos[1].x)<=2) continue;              // LrZ
      if(pos[0].x!=pos[3].x)  { return(0); }
      break;
   }
   *marky =pos[0].y+1;
   *marky1=pos[2].y-1;
   *markx =pos[2].x+2;
   *markx1=pos[0].x-1;
   return(1);

   //MarkPush();
   //CTRL.MARK=ON;
   //CTRL.MARKFILE=ACTIVE;
   //
   //POS.MARKY =pos[0].y+1;
   //POS.MARKY1=pos[2].y-1;
   //POS.MARKX =pos[2].x+2;
   //POS.MARKX1=pos[0].x-1;
   //
   //CompareRedraw(1,(LINE.SCRY1-LINE.SCRY+1));
   //Redraw(DISPLAY.SCRY,DISPLAY.CNT);
   //LightLine();
   //StatusXY();
   //
   //MarkInput();
   //
   //UnMark();
   //MarkPop();
}
