
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <fcntl.h>
#include <io.h>
#include <stdlib.h>
#include "we.h"
#include "tools.h"
#include "macro.h"
#include "profile.h"

#define  ON     1
#define  OFF    0

extern struct STRINGCOLOR_STRUCT        SC;
extern struct PROKEY_STRUCT             *PROKEY_HEAD;
extern struct LINE_STRUCT               LINE;
extern struct SET_STRUCT                SET;
extern struct CTRL_STRUCT               CTRL;
extern int    MONITOR;

int ProfileRead(char *fname)
{
   int                    fhandle;
   int                    line_cnt=0;
   int                    wcnt=0,cnt;
   int                    i,SW;
   unsigned               size,sw;
   int                    ERROR=OFF;
   int                    EXIT =OFF;
   char                   *ts,*ts1;
   char                   data[513],str[256],str1[256],str2[256],cmd[256];
   struct PROKEY_STRUCT   *pnew;
   struct PROKEY_STRUCT   *pnow;
   struct PROKEY_STRUCT   *ptmp;

   struct KEY_STRUCT
   {
      int  funckey;
      int  keystatus;
      int  code;
      char key[8];
   };

   struct KEY_STRUCT KEY[]=
   {
      { ON  , 0x00, 0x48, "up"       },
      { ON  , 0x00, 0x50, "down"     },
      { ON  , 0x00, 0x4b, "left"     },
      { ON  , 0x00, 0x4d, "right"    },
      { ON  , 0x00, 0x47, "home"     },
      { ON  , 0x00, 0x4f, "end"      },
      { ON  , 0x00, 0x49, "pgup"     },
      { ON  , 0x00, 0x51, "pgdn"     },
      { OFF , 0x00, 0x09, "tab"      },
      { ON  , 0x00, 0x52, "ins"      },
      { ON  , 0x00, 0x53, "del"      },
      { ON  , 0x01, 0x0f, "s-tab"    },
      { ON  , 0x08, 0x98, "a-up"     },
      { ON  , 0x08, 0xa0, "a-down"   },
      { ON  , 0x08, 0x9b, "a-left"   },
      { ON  , 0x08, 0x9d, "a-right"  },
      { ON  , 0x08, 0x97, "a-home"   },
      { ON  , 0x08, 0x9f, "a-end"    },
      { ON  , 0x08, 0x99, "a-pgup"   },
      { ON  , 0x08, 0xa1, "a-pgdn"   },
      { ON  , 0x04, 0x73, "c-left"   },
      { ON  , 0x04, 0x74, "c-right"  },
//    { ON  , 0x04, 0x8d, "c-up"     },
//    { ON  , 0x04, 0x91, "c-down"   },
      { ON  , 0x04, 0x77, "c-home"   },
      { ON  , 0x04, 0x75, "c-end"    },
      { ON  , 0x04, 0x84, "c-pgup"   },
      { ON  , 0x04, 0x76, "c-pgdn"   },
//    { OFF , 0x04, 0x01, "c-a"      },
//    { OFF , 0x04, 0x02, "c-b"      },
//    { OFF , 0x04, 0x03, "c-c"      },
//    { OFF , 0x04, 0x15, "c-u"      },
//    { ON  , 0x04, 0x93, "c-del"    },
//    { OFF , 0x04, 0x7f, "c-bs"     },
//    { OFF , 0x04, 0x0a, "c-enter"  },
      { OFF , 0x04, 0x04, "c-d"      },
      { OFF , 0x04, 0x05, "c-e"      },
      { OFF , 0x04, 0x06, "c-f"      },
      { OFF , 0x04, 0x07, "c-g"      },
      { OFF , 0x04, 0x08, "c-h"      },
      { OFF , 0x04, 0x09, "c-i"      },
//    { OFF , 0x04, 0x0a, "c-j"      },                 P Ctrl-Enter X
      { OFF , 0x04, 0x0b, "c-k"      },
      { OFF , 0x04, 0x0c, "c-l"      },
      { OFF , 0x04, 0x0d, "c-m"      },
      { OFF , 0x04, 0x0e, "c-n"      },
      { OFF , 0x04, 0x0f, "c-o"      },
      { OFF , 0x04, 0x10, "c-p"      },
      { OFF , 0x04, 0x11, "c-q"      },
//    { OFF , 0x04, 0x12, "c-r"      },
      { OFF , 0x04, 0x13, "c-s"      },
      { OFF , 0x04, 0x14, "c-t"      },
      { OFF , 0x04, 0x16, "c-v"      },
      { OFF , 0x04, 0x17, "c-w"      },
      { OFF , 0x04, 0x18, "c-x"      },
      { OFF , 0x04, 0x19, "c-y"      },
      { OFF , 0x04, 0x1a, "c-z"      },
      { ON  , 0x04, 0x92, "c-ins"    },
//    { ON  , 0x04, 0x94, "c-tab"    },
      { ON  , 0x08, 0x1e, "a-a"      },
//    { ON  , 0x08, 0x30, "a-b"      },
//    { ON  , 0x08, 0x2e, "a-c"      },
//    { ON  , 0x08, 0x20, "a-d"      },
      { ON  , 0x08, 0x12, "a-e"      },
      { ON  , 0x08, 0x21, "a-f"      },
      { ON  , 0x08, 0x22, "a-g"      },
      { ON  , 0x08, 0x23, "a-h"      },
      { ON  , 0x08, 0x17, "a-i"      },
      { ON  , 0x08, 0x24, "a-j"      },
//    { ON  , 0x08, 0x26, "a-l"      },
//    { ON  , 0x08, 0x32, "a-m"      },
      { ON  , 0x08, 0x31, "a-n"      },
//    { ON  , 0x08, 0x18, "a-o"      },
//    { ON  , 0x08, 0x19, "a-p"      },
//    { ON  , 0x08, 0x10, "a-q"      },
      { ON  , 0x08, 0x13, "a-r"      },
      { ON  , 0x08, 0x1f, "a-s"      },
      { ON  , 0x08, 0x14, "a-t"      },
//    { ON  , 0x08, 0x16, "a-u"      },
//    { ON  , 0x08, 0x2f, "a-v"      },
      { ON  , 0x08, 0x11, "a-w"      },
      { ON  , 0x08, 0x2d, "a-x"      },
      { ON  , 0x08, 0x15, "a-y"      },
//    { ON  , 0x08, 0x2c, "a-z"      },
//    { ON  , 0x08, 0xa5, "a-tab"    },
//    { ON  , 0x00, 0x3b, "f1"       },
//    { ON  , 0x00, 0x3c, "f2"       },
//    { ON  , 0x00, 0x3d, "f3"       },
//    { ON  , 0x00, 0x3e, "f4"       },
//    { ON  , 0x00, 0x3f, "f5"       },
//    { ON  , 0x00, 0x40, "f6"       },
//    { ON  , 0x00, 0x41, "f7"       },
//    { ON  , 0x00, 0x42, "f8"       },
//    { ON  , 0x00, 0x43, "f9"       },
//    { ON  , 0x00, 0x44, "f10"      },
      { ON  , 0x00, 0x85, "f11"      },
      { ON  , 0x00, 0x86, "f12"      },
      { ON  , 0x08, 0x68, "a-f1"     },
      { ON  , 0x08, 0x69, "a-f2"     },
      { ON  , 0x08, 0x6a, "a-f3"     },
      { ON  , 0x08, 0x6b, "a-f4"     },
      { ON  , 0x08, 0x6c, "a-f5"     },
      { ON  , 0x08, 0x6d, "a-f6"     },
      { ON  , 0x08, 0x6e, "a-f7"     },
      { ON  , 0x08, 0x6f, "a-f8"     },
      { ON  , 0x08, 0x70, "a-f9"     },
      { ON  , 0x08, 0x71, "a-f10"    },
      { ON  , 0x08, 0x8b, "a-f11"    },
      { ON  , 0x08, 0x8c, "a-f12"    },
      { ON  , 0x04, 0x5e, "c-f1"     },
      { ON  , 0x04, 0x5f, "c-f2"     },
      { ON  , 0x04, 0x60, "c-f3"     },
      { ON  , 0x04, 0x61, "c-f4"     },
      { ON  , 0x04, 0x62, "c-f5"     },
      { ON  , 0x04, 0x63, "c-f6"     },
      { ON  , 0x04, 0x64, "c-f7"     },
      { ON  , 0x04, 0x65, "c-f8"     },
      { ON  , 0x04, 0x66, "c-f9"     },
      { ON  , 0x04, 0x67, "c-f10"    },
      { ON  , 0x04, 0x89, "c-f11"    },
      { ON  , 0x04, 0x8a, "c-f12"    },
      { ON  , 0x02, 0x54, "s-f1"     },
      { ON  , 0x02, 0x55, "s-f2"     },
      { ON  , 0x02, 0x56, "s-f3"     },
      { ON  , 0x02, 0x57, "s-f4"     },
      { ON  , 0x02, 0x58, "s-f5"     },
      { ON  , 0x02, 0x59, "s-f6"     },
//    { ON  , 0x02, 0x5a, "s-f7"     },
//    { ON  , 0x02, 0x5b, "s-f8"     },
      { ON  , 0x02, 0x5c, "s-f9"     },
      { ON  , 0x02, 0x5d, "s-f10"    },
      { ON  , 0x02, 0x87, "s-f11"    },
      { ON  , 0x02, 0x88, "s-f12"    },
      { ON  , 0x02, 0x48, "s-up"     },
      { ON  , 0x02, 0x50, "s-down"   },
      { ON  , 0x02, 0x4b, "s-left"   },
      { ON  , 0x02, 0x4d, "s-right"  },
      { ON  , 0x02, 0x47, "s-home"   },
      { ON  , 0x02, 0x4f, "s-end"    },
      { ON  , 0x02, 0x49, "s-pgup"   },
      { ON  , 0x02, 0x51, "s-pgdn"   },
      { ON  , 0x08, 0xa2, "a-ins"    },
      { OFF , 0x00, 0x00, "\0"       }
   };

   PROKEY_HEAD=NULL;
   pnow       =NULL;
   pnew       =NULL;
   ptmp       =NULL;

   // -------- o㪺ɮצW, P_ɮ׬O_r  --------
   if(GetFullFname(str,fname)==-1) return(-1);
   i=ChkIsText(str);
   if(i==-1 || i==0)               return(-1);

   // ------------------------ ɮŪJ -------------------------
   fhandle=open(str,O_RDWR | O_TEXT);
   if(fhandle==-1)                 return(-2);

   while(!EXIT)
   {
      // ----------------------- ŪJ@ -----------------------
      ts   =str;
      *ts  ='\0';
      while(1)
      {
         if(wcnt==0)
         {
            if((wcnt=read(fhandle,data,512))==0) { EXIT=ON; break; }
            ts1=data;
         }

         if(*ts1==0x0a || *ts1==0x0d) { wcnt--; ts1++; line_cnt++; break; }
         if(*ts1==0x09) { for(i=0;i<TAB_SPACE;i++) *ts++=' '; } else { *ts++=*ts1; }
         ts1++;
         wcnt--;
      }
      *ts='\0';

      // ----------------- '#' H ---------------------
      for(i=0;i<strlen(str);i++)  { if(str[i]=='#') { str[i]='\0'; break; } }

      if(!EraseSpace(str)) continue;

      // ---------------- P_ '[]' O_ --------------------
      ERROR=OFF;
      for(i=0,cnt=0; i<strlen(str); i++)
      {
         if(str[i]=='[') { cnt++; if(cnt>1) { ERROR=ON; break; } }
         if(str[i]==']') { cnt--; if(cnt<0) { ERROR=ON; break; } }
      }

      // --------------- X '=' ᪺O ----------------
      for(i=0,str1[0]='\0'; i<strlen(str); i++)
      {
         if(str[i]=='=') { strcpy(str1,&str[i+1]); EraseSpace(str1); break;  }
      }

      // ---------- P_}YrO_ 'def'  'set' -----------
      ts=strtok(str," ");
      strcpy(cmd,ts);
      EraseSpace(cmd);
      if(stricmp(cmd,"def")!=0 && stricmp(cmd,"set")!=0) continue;

      if(stricmp(cmd,"set")==0)
      {
         sw=0;
         ts=strtok(NULL," ");
         if(stricmp(ts,"ExactSearch")==0) sw=1;
         if(stricmp(ts,"TIMER")      ==0) sw=2;
         if(stricmp(ts,"BEEP")       ==0) sw=3;
         if(stricmp(ts,"RELATION")   ==0) sw=4;
         if(stricmp(ts,"AUTOPAGE")   ==0) sw=5;
         if(stricmp(ts,"STRINGCOLOR")==0) sw=6;
         if(stricmp(ts,"Share")      ==0) sw=7;
         if(stricmp(ts,"DIR")==0)
         {
            ts=strtok(NULL," ");
            if(stricmp(ts,"NAME")==0) SET.DIR=1;
            if(stricmp(ts,"DATE")==0) SET.DIR=2;
            if(stricmp(ts,"SIZE")==0) SET.DIR=3;
            continue;
         }
         if(stricmp(ts,"AutoSave")==0)
         {
            ts=strtok(NULL," ");     SET.AUTOSAVE=atoi(ts);   continue;
         }
         if(stricmp(ts,"Sleep")==0)
         {
            ts=strtok(NULL," ");     SET.SLEEP=atoi(ts);
            if(SET.SLEEP<0)  SET.SLEEP=0;
            if(SET.SLEEP==1) SET.SLEEP=2;
            continue;
         }
         if(stricmp(ts,"COLOR")==0)
         {
            ts=strtok(NULL," ");     SET.EDITCOLOR=atoi(ts);
            if(SET.EDITCOLOR<1 || SET.EDITCOLOR>7) SET.EDITCOLOR=0x07;
            if(MONITOR==MONO) SET.EDITCOLOR=0x07;
            continue;
         }

         if(sw)
         {
            ts=strtok(NULL," ");
            if(stricmp(ts,"ON")==0)
            {
               switch(sw)
               {
                 case 1: SET.SEARCHCASE=ON;  break;
                 case 2: SET.TIMER     =ON;  break;
                 case 3: SET.BEEP      =ON;  break;
                 case 4: SET.RELATION  =ON;  break;
                 case 5: SET.AUTOPAGE  =ON;  break;
                 case 7: SET.SHARE     =ON;  break;
               }
            }
            if(stricmp(ts,"OFF")==0)
            {
               switch(sw)
               {
                 case 1: SET.SEARCHCASE=OFF; break;
                 case 2: SET.TIMER     =OFF; break;
                 case 3: SET.BEEP      =OFF; break;
                 case 4: SET.RELATION  =OFF; break;
                 case 5: SET.AUTOPAGE  =OFF; break;
                 case 7: SET.SHARE     =OFF; break;
               }
            }
            if(sw==6)
            {
               ProfileStringColor(ts,strtok(NULL," "));
            }
         }
         continue;
      }

      if(str1[0]=='\0') continue;               // 'def =' Lr
      // --------------- P_O_Xkwq ---------------
      SW=0;
      ts=strtok(NULL,"=");
      strcpy(cmd,ts);
      EraseSpace(cmd);
      while(KEY[SW].key[0]!='\0')
      {
         if(stricmp(KEY[SW].key,cmd)==0) break; else SW++;
      }
      if(KEY[SW].key[0]=='\0') continue;

      // -------------- P_eO_wJۦPwq ---------------
      ptmp=PROKEY_HEAD;
      while(ptmp!=NULL)
      {
         if((*ptmp).keystatus==KEY[SW].keystatus && (*ptmp).code==KEY[SW].code &&
            (*ptmp).funckey  ==KEY[SW].funckey) break;
         ptmp=ptmp->next;
      }
      if(ptmp!=NULL) continue;

      // ------------------ P_O_XkO ---------------------
      //if((ts=strtok(NULL,"[]"))!=NULL)
      strcpy(str2,str1);
      if((ts=strtok(str2,"[]"))!=NULL)
      {
         strcpy(cmd,ts);
         EraseSpace(cmd);
         if(MacroID(cmd)==-1) { ERROR=ON; }
      }

      while(ts!=NULL)
      {
         if((ts=strtok(NULL,"[]"))!=NULL)
         {
            strcpy(cmd,ts);
            EraseSpace(cmd);
            if(MacroID(cmd)==-1)
            {
               ERROR=ON;
               break;
            }
         }
      }

      if(!ERROR)
      {
         size=(sizeof(struct PROKEY_STRUCT)+(strlen(str1)+1)+15)>>4;
         if(allocmem(size,&sw)!=-1) continue;
         pnew             =(struct PROKEY_STRUCT *)MK_FP(sw,0);
         (*pnew).funckey  =KEY[SW].funckey;
         (*pnew).keystatus=KEY[SW].keystatus;
         (*pnew).code     =KEY[SW].code;
         pnew->macro      =(char *)pnew+14;
         pnew->next       =NULL;
         strcpy(pnew->macro,str1);
         if(PROKEY_HEAD==NULL) { PROKEY_HEAD=pnew; } else { pnow->next=pnew; }
         pnow=pnew;
      }
      else
      {
         sprintf(str1,"wq(EE.PRO)  %d yk~ (Press a key)",line_cnt);
         ColorPuts1(1,LINE.MESSAGE,str1,F_MAGENTA|F_INTENSE);
         getch();
         RollUp( 1, 1, LINE.MESSAGE, 80, LINE.MESSAGE, 0x07);
      }
   }
   close(fhandle);
   return(0);
}

void ProfileKey(int funckey, int keystatus, int code)
{
   struct PROKEY_STRUCT *ptmp;

   ptmp=PROKEY_HEAD;
   while(ptmp!=NULL)
   {
      if((*ptmp).keystatus==keystatus && (*ptmp).code==code &&
         (*ptmp).funckey  ==funckey) break;
      ptmp=ptmp->next;
   }

   if(ptmp==NULL)                { return; }
   CTRL.PROKEY=ON;
   if(MacroStr(ptmp->macro)==-1) { DisplayMessage("~ : 䪺wqyk~",ON); }
   CTRL.PROKEY=OFF;
}

void ProfileFree()
{
   struct PROKEY_STRUCT   *pnow=NULL;
   struct PROKEY_STRUCT   *ptmp=NULL;

   pnow=PROKEY_HEAD;
   while(ptmp!=NULL)
   {
      ptmp=pnow->next;
      freemem(FP_SEG(pnow));
      pnow=ptmp;
   }
   PROKEY_HEAD=NULL;
}

void ProfileBasic()
{
   int                    SW=0;
   unsigned               size,sw;
   struct PROKEY_STRUCT   *pnew;
   struct PROKEY_STRUCT   *pnow;
   struct PROKEY_STRUCT   *ptmp;

   struct KEY_STRUCT
   {
      int  funckey;
      int  keystatus;
      int  code;
      char key[8];
      char macro[15];
   };

   struct KEY_STRUCT KEY[]=
   {
      { ON  , 0x00, 0x48, "up"    , "[Up]"          },
      { ON  , 0x00, 0x50, "down"  , "[Down]"        },
      { ON  , 0x00, 0x4b, "left"  , "[Left]"        },
      { ON  , 0x00, 0x4d, "right" , "[Right]"       },
      { ON  , 0x00, 0x47, "home"  , "[BeginLine]"   },
      { ON  , 0x00, 0x4f, "end"   , "[EndLine]"     },
      { ON  , 0x00, 0x49, "pgup"  , "[PageUp]"      },
      { ON  , 0x00, 0x51, "pgdn"  , "[PageDown]"    },
      { OFF , 0x00, 0x09, "tab"   , "[Tab]"         },
      { ON  , 0x00, 0x52, "ins"   , "[InsertToggle]"},
      { ON  , 0x00, 0x53, "del"   , "[DeleteChar]"  },
      { ON  , 0x02, 0x0f, "s-tab" , "[BackTab]"     },
      { ON  , 0x04, 0x77, "c-home", "[Top]"         },
      { ON  , 0x04, 0x75, "c-end" , "[Bottom]"      },
      { ON  , 0x04, 0x84, "c-pgup", "[TopEdge]"     },
      { ON  , 0x04, 0x76, "c-pgdn", "[BottomEdge]"  },
      { OFF , 0x00, 0x00, "\0"    , "\0"            }
   };

   // ------------------ pnow ̫@ -----------------------
   ptmp=PROKEY_HEAD;
   if(ptmp!=NULL)
   {
      while(ptmp->next!=NULL) ptmp=ptmp->next;
      pnow=ptmp;
   }

   // ------------------ P_O_wQwq --------------------
   while(KEY[SW].key[0]!='\0')
   {
      ptmp=PROKEY_HEAD;
      while(ptmp!=NULL)
      {
         if((*ptmp).keystatus==KEY[SW].keystatus && (*ptmp).code==KEY[SW].code &&
            (*ptmp).funckey  ==KEY[SW].funckey) break;
         ptmp=ptmp->next;
      }

      if(ptmp==NULL)
      {
         size=(sizeof(struct PROKEY_STRUCT)+(strlen(KEY[SW].macro)+1)+15)>>4;
         if(allocmem(size,&sw)!=-1) continue;
         pnew             =(struct PROKEY_STRUCT *)MK_FP(sw,0);
         (*pnew).funckey  =KEY[SW].funckey;
         (*pnew).keystatus=KEY[SW].keystatus;
         (*pnew).code     =KEY[SW].code;
         pnew->macro      =(char *)pnew+14;
         pnew->next       =NULL;
         strcpy(pnew->macro,KEY[SW].macro);
         if(PROKEY_HEAD==NULL) { PROKEY_HEAD=pnew; } else { pnow->next=pnew; }
         pnow=pnew;
      }
      SW++;
   }
}

void ProfileStringColor(char *kstr, char *cstr)
{
   int sw;

   sw=strlen(kstr);
   if(sw<2 || sw>8) return;                     // keystr  >2 && <8 ~
   if(SC.cnt==32)   return;                     // ̦h 32 ռ

   for(sw=0; sw<SC.cnt; sw++)
   {
      if(strcmp(SC.str[sw],kstr)==0) return;
   }

   sw=0;
   if(stricmp(cstr,"BLUE"     )==0) sw=0x01;
   if(stricmp(cstr,"GREEN"    )==0) sw=0x02;
   if(stricmp(cstr,"CYAN"     )==0) sw=0x03;
   if(stricmp(cstr,"RED"      )==0) sw=0x04;
   if(stricmp(cstr,"MAGENTA"  )==0) sw=0x05;
   if(stricmp(cstr,"BROWN"    )==0) sw=0x06;
   if(stricmp(cstr,"GRAY"     )==0) sw=0x07;

   if(sw)
   {
      strcpy(SC.str[SC.cnt],kstr);
      SC.color[SC.cnt]=sw;
      SC.cnt++;
   }
}
